Loading...
Searching...
No Matches
BALL::VIEW Namespace Reference

## Classes

class | ColorExtension2
class | MultiColorExtension
class | ColorHSV
class | ColorMap
class | ColorRGBA
class | ColorUnit
class | ColorUnitHue
class | Dataset
class | DatasetController
class | RaytraceableGrid
class | RegularData3DController
class | TrajectoryController
class | DockResultController
class | VectorGridController
class | RaytraceableGridController
class | Vertex
class | Vertex2
class | AmberConfigurationDialog
class | AssignBondOrderConfigurationDialog
class | AssignBondOrderResultsDialog
class | AtomOverview
class | BondProperties
class | CharmmConfigurationDialog
class | ClippingDialog
class | ColoringSettingsDialog
class | CompositeProperties
class | ContourSurfaceDialog
class | DisplayProperties
class | DockDialog
class | DockProgressDialog
class | DockResultDialog
class | DownloadElectronDensity
class | DownloadPDBFile
class | EditSettings
class | EditSingleShortcut
class | ExportGeometryDialog
class | FDPBDialog
class | FieldLinesDialog
class | GenerateCrystalDialog
class | GeometricFitDialog
class | GridVisualizationDialog
class | LabelDialog
class | LightSettings
class | MainControlPreferences
class | MaterialSettings
class | MinimizationDialog
class | MMFF94ConfigurationDialog
class | ModelSettingsDialog
class | ModifyRepresentationDialog
class | MolecularDynamicsDialog
class | MolecularFileDialog
class | NetworkPreferences
class | OpenSavePreferences
class | ParsedFunctionDialog
class | PeptideDialog
class | PluginModel
class | PluginDirectoryModel
class | PluginDialog
class | Preferences
class | PTEDialog
class | PubChemDialog
class | PythonSettings
class | RaytraceableContourSurfaceDialog
class | ServerPreferences
class | SetCamera
class | SetClippingPlane
class | ShortcutDialog
class | SnapshotVisualisationDialog
class | StageSettings
class | StereoSettingsDialog
class | UndoManagerDialog
class | ButtonEvent
class | DeviceEvent
class | FakeDriver
class | HeadTrackingEvent
class | InputDeviceDriver
class | InputPlugin
class | MotionTrackingEvent
class | NotificationEvent
class | TransformationEvent6D
class | ClippingPlane
class | LogEvent
| Event class used for thread safe output to logview. More...
class | CompositeManager
class | ConnectionObject
class | EditOperation
class | GeometricObject
class | IconLoader
class | MainControl
class | Message
class | DatasetMessage
class | CompositeMessage
class | SceneMessage
class | GenericSelectionMessage
class | ControlSelectionMessage
class | NewSelectionMessage
class | GeometricObjectSelectionMessage
class | RepresentationMessage
| Base class for all messages concerning a Representation. More...
class | MolecularTaskMessage
class | ShowDisplayPropertiesMessage
class | CreateRepresentationMessage
class | DeselectControlsMessage
class | TransformationMessage
class | FinishedSimulationMessage
class | SyncClippingPlanesMessage
class | ShowHelpMessage
class | RegisterHelpSystemMessage
class | DockingFinishedMessage
| Message to notify docking has finished. More...
class | ModelInformation
class | EditMode
class | InteractionMode
class | InteractionModeManager
class | MoveMode
class | PickingMode
class | RotateMode
class | ModularWidget
class | PreferencesEntry
class | Representation
class | RepresentationManager
class | ServerWidget
class | ShortcutRegistry
class | SnapshotManagerInterface
class | LightSource
class | Stage
class | MessageEvent
class | BALLThread
class | CalculateFDPBThread
class | GenerateCrystalThread
class | UpdateRepresentationThread
class | SimulationThread
class | EnergyMinimizerThread
| Thread for EnergyMinimization. More...
class | MDSimulationThread
| Thread for MDSimulation. More...
class | DockingThread
| Thread for Docking. More...
class | UIOperationMode
class | AtomBondModelBaseProcessor
class | AddBackboneModel
class | AddBallAndStickModel
class | AddCartoonModel
class | ColorByGridProcessor
class | ColorProcessor
class | InterpolateColorProcessor
class | FieldLineCreator
class | ForceModel
class | HBondModelProcessor
class | LabelModel
class | AddLineModel
class | ModelProcessor
class | ElementColorProcessor
class | ResidueNumberColorProcessor
class | PositionColorProcessor
class | ChainColorProcessor
class | MoleculeColorProcessor
class | ResidueNameColorProcessor
class | AtomChargeColorProcessor
class | AtomDistanceColorProcessor
class | CustomColorProcessor
class | TemperatureFactorColorProcessor
class | OccupancyColorProcessor
class | ForceColorProcessor
class | SecondaryStructureColorProcessor
class | ResidueTypeColorProcessor
class | AddSurfaceModel
class | AddVanDerWaalsModel
class | InputDevPluginHandler
class | ModularWidgetPlugin
class | ModularWidgetPluginHandler
class | ConfigDialog
class | VIEWPlugin
class | Box
class | Disc
class | GridVisualisation
class | Label
class | Line
class | Mesh
class | MultiLine
class | Point
class | QuadMesh
class | SimpleBox
class | Sphere
class | Tube
class | TwoColoredLine
class | TwoColoredTube
class | Camera
class | GLDisplayList
class | GLOffscreenTarget
class | GLRenderWindow
struct | ChannelFormat
class | PixelFormat
class | BufferedRenderer
class | CudaVolumeRenderer
class | GLRenderer
class | POVRenderer
class | RaytracingRenderer
class | Renderer
class | RTfactRenderer
class | STLRenderer
class | TilingRenderer
class | VRMLRenderer
class | XML3DRenderer
class | RenderSetup
class | RenderToBufferFinishedEvent
struct | Resolution
class | FrameBufferFormat
class | FrameBuffer
class | RenderTarget
class | TRenderWindow
class | MeshBuffer
class | ColorButton
class | ColorTable
class | DatasetControl
class | DockingController
class | DockWidget
class | FileObserver
class | TreeWidget
class | GenericControl
class | GeometricControl
class | GridColorWidget
class | MyTextBrowser
class | HelpViewer
class | ComboBoxDelegate
class | HotkeyTable
class | HTMLPage
class | HTMLViewErrorWidget
class | HTMLView
class | HTMLViewDock
class | DragLogView
class | LogView
class | MolecularControl
class | MolecularStructure
class | PropEditorWidget
class | BoolEditorWidget
class | IntEditorWidget
class | UIntEditorWidget
class | FloatEditorWidget
class | DoubleEditorWidget
class | StringEditorWidget
class | PropDeleteWidget
class | PDBInfoEditorWidget
class | PropertyEditor
class | PythonHighlighter
class | PythonValidator
class | RunPythonThread
struct | Hotkey
class | PyWidget
class | Scene
class | AnimationThread
class | SDWidget
class | ShortcutTableView
class | ShortcutTableModel
class | TestFramework
class | TextEditorWidget

## Typedefs

typedef TRegularData3D< Vector3 > | VectorGrid
typedef QFlags< InputDeviceButton > | InputDeviceButtons
typedef std::list< GeometricObject * > | GeometricObjectList
typedef std::list< Representation * > | RepresentationList
typedef std::vector< FrameBufferFormat > | BufferFormatList
typedef boost::shared_ptr< FrameBuffer > | FrameBufferPtr
typedef TRenderWindow< BALL_DEFAULT_PIXEL_TYPE > | RenderWindow

## Enumerations

enum | InputDeviceButton { BUTTON1 = 1 << 0 , BUTTON2 = 1 << 1 , BUTTON3 = 1 << 2 , BUTTON4 = 1 << 3 , BUTTON5 = 1 << 4 , BUTTON6 = 1 << 5 , BUTTON7 = 1 << 6 , BUTTON8 = 1 << 7 , BUTTON9 = 1 << 8 , BUTTON10 = 1 << 9 , BUTTON11 = 1 << 10 , BUTTON12 = 1 << 11 }
General enumerations, methods and typedefs
These predefined types are used in VIEW for portability and comprehensibility.
enum | EventsIDs { MESSAGE_EVENT = 60000 , LOG_EVENT , TRANSFORMATION_EVENT_6D , HEADTRACKING_EVENT , MOTIONTRACKING_EVENT , BUTTON_PRESS_EVENT , BUTTON_RELEASE_EVENT , NOTIFICATION_EVENT , RENDER_TO_BUFFER_FINISHED_EVENT }

## Functions

std::ostream & | operator<< (std::ostream &o, const PixelFormat &f)
std::ostream & | operator<< (std::ostream &o, const FrameBufferFormat &f)

## Variables

ColorRGBA | BALL_SELECTED_COLOR
PreciseTime | BALL_SELECTED_COLOR_CHANGE_TIME

## Enumerations for Representations and Renderer

Enums and methods to describe the models and drawing methods.
enum | DrawingMode { DRAWING_MODE_DOTS = 0 , DRAWING_MODE_WIREFRAME , DRAWING_MODE_SOLID , DRAWING_MODE_TOON }
| Enumeration for Drawing Modes. More...
enum | DrawingPrecision { DRAWING_PRECISION_INVALID = -1 , DRAWING_PRECISION_LOW = 0 , DRAWING_PRECISION_MEDIUM , DRAWING_PRECISION_HIGH , DRAWING_PRECISION_ULTRA }
| Enumeration for Drawing Precisions. More...

enum

ModelType {
MODEL_LINES = 0 , MODEL_STICK , MODEL_BALL_AND_STICK , MODEL_VDW ,
MODEL_SE_SURFACE , MODEL_SA_SURFACE , MODEL_BACKBONE , MODEL_CARTOON ,
MODEL_RIBBON , MODEL_HBONDS , MODEL_FORCES , MODEL_LABEL = 100 ,
MODEL_CONTOUR_SURFACE , MODEL_GRID_SLICE , MODEL_GRID_VOLUME , MODEL_FIELD_LINES ,
MODEL_INFORMATIONS , MODEL_COORDINATE_SYSTEM , MODEL_PROXIMITY_LIGHT , MODEL_PLANE ,
MODEL_SPHERE , MODEL_UNKNOWN = 200
}

enum | ColoringMethod { COLORING_ELEMENT = 0 , COLORING_RESIDUE_INDEX , COLORING_RESIDUE_NAME , COLORING_SECONDARY_STRUCTURE , COLORING_ATOM_CHARGE , COLORING_DISTANCE , COLORING_TEMPERATURE_FACTOR , COLORING_OCCUPANCY , COLORING_FORCES , COLORING_RESIDUE_TYPE , COLORING_CHAIN , COLORING_MOLECULE , COLORING_CUSTOM , COLORING_UNKNOWN = 200 }
BALL_VIEW_EXPORT float | SurfaceDrawingPrecisions [4]
| Mapping from the enum to the float values of Surfaces.
BALL_VIEW_EXPORT Composite | composite_to_be_ignored_for_colorprocessors_
float | icosaeder_vertices [12][3]
| Code to refine a icosaeder:
Position | icosaeder_indices [20][3]
BALL_VIEW_EXPORT String | vector3ToString (const Vector3 &v)
BALL_VIEW_EXPORT bool | stringToVector3 (const String &data, Vector3 &v)
BALL_VIEW_EXPORT String | createFloatString (float value, Size precision)
| create a string from a float and cut after a given number of digits after the dot
BALL_VIEW_EXPORT MainControl * | getMainControl ()
BALL_VIEW_EXPORT String | createTemporaryFilename ()
| Create a temporary filename in the users home dir.
BALL_VIEW_EXPORT Vector3 | getNormal (const Vector3 &v)
BALL_VIEW_EXPORT void | logString (const String &data)
| thread safe output to logview
BALL_VIEW_EXPORT void | processDropEvent (QDropEvent *e)
BALL_VIEW_EXPORT Camera | focusCamera (Composite *composite)
BALL_VIEW_EXPORT Camera | focusCamera (const std::list< Vector3 > &points)
BALL_VIEW_EXPORT String | ascii (const QString &str)
BALL_VIEW_EXPORT ColorRGBA | getColor (const QLabel *label)
BALL_VIEW_EXPORT void | setColor (const QLabel *label, const ColorRGBA &color)
BALL_VIEW_EXPORT QColor | chooseColor (QLabel *label)
BALL_VIEW_EXPORT void | setTextColor (QLabel *label, const ColorRGBA &color)
BALL_VIEW_EXPORT void | cubicInterpolation (const Vector3 &a, const Vector3 &b, const Vector3 &tangent_a, const Vector3 &tangent_b, std::vector< Vector3 > &interpolated_values)
BALL_VIEW_EXPORT void | subdivideTriangle (vector< Vector3 > &results, Vector3 &v1, Vector3 &v2, Vector3 &v3, Size precision)
BALL_VIEW_EXPORT vector< Vector3 > | createSphere (Size precision)
BALL_VIEW_EXPORT void | calculateHistogramEqualization (const vector< float > &values, vector< float > &normalized_values, bool use_absolute_values=false)
BALL_VIEW_EXPORT void | calculateRandomPoints (const RegularData3D &grid, Size nr_points, vector< Vector3 > &resulting_points)
| calcualte a random set of points, dependening of the field strength of a grid

## Typedef Documentation

## BufferFormatList

typedef std::vector<FrameBufferFormat> BALL::VIEW::BufferFormatList

Definition at line 170 of file renderTarget.h.

## FrameBufferPtr

typedef boost::shared_ptr<FrameBuffer> BALL::VIEW::FrameBufferPtr

Definition at line 222 of file renderTarget.h.

## GeometricObjectList

typedef std::list<GeometricObject*> BALL::VIEW::GeometricObjectList

Definition at line 185 of file geometricObject.h.

## InputDeviceButtons

typedef QFlags<InputDeviceButton> BALL::VIEW::InputDeviceButtons

Definition at line 28 of file buttonEvent.h.

## RenderWindow

typedef TRenderWindow<BALL_DEFAULT_PIXEL_TYPE> BALL::VIEW::RenderWindow

Definition at line 115 of file renderWindow.h.

## RepresentationList

typedef std::list<Representation*> BALL::VIEW::RepresentationList

Definition at line 342 of file representation.h.

## VectorGrid

typedef TRegularData3D<Vector3> BALL::VIEW::VectorGrid

Definition at line 251 of file standardDatasets.h.

## Enumeration Type Documentation

## ColoringMethod

enum BALL::VIEW::ColoringMethod

Enumeration for Coloring Methods. Add new coloring methods before COLORING_CUSTOM.

Enumerator
COLORING_ELEMENT |
COLORING_RESIDUE_INDEX |
COLORING_RESIDUE_NAME |
COLORING_SECONDARY_STRUCTURE |
COLORING_ATOM_CHARGE |
COLORING_DISTANCE |
COLORING_TEMPERATURE_FACTOR |
COLORING_OCCUPANCY |
COLORING_FORCES |
COLORING_RESIDUE_TYPE |
COLORING_CHAIN |
COLORING_MOLECULE |
COLORING_CUSTOM |
COLORING_UNKNOWN |

Definition at line 242 of file VIEW/KERNEL/common.h.

## DrawingMode

enum BALL::VIEW::DrawingMode

Enumeration for Drawing Modes.

Enumerator
DRAWING_MODE_DOTS |
DRAWING_MODE_WIREFRAME |
DRAWING_MODE_SOLID |
DRAWING_MODE_TOON |

Definition at line 109 of file VIEW/KERNEL/common.h.

## DrawingPrecision

enum BALL::VIEW::DrawingPrecision

Enumeration for Drawing Precisions.

Enumerator
DRAWING_PRECISION_INVALID |
DRAWING_PRECISION_LOW |
DRAWING_PRECISION_MEDIUM |
DRAWING_PRECISION_HIGH |
DRAWING_PRECISION_ULTRA |

Definition at line 128 of file VIEW/KERNEL/common.h.

## EventsIDs

enum BALL::VIEW::EventsIDs

Enumeration of Events These events are used to communicate between different threads. Have a look at QWidget::customEvent(QEvent*) to learn about QT and its events concept. This enum is used to give every type of derived QEvent its individual type id.

Enumerator
MESSAGE_EVENT | An event with a contained VIEW message.
LOG_EVENT | Event to print output from a Thread.
TRANSFORMATION_EVENT_6D | Event that encodes a 6 dimensional transformation.
HEADTRACKING_EVENT | Event that encodes a head tracker position change.
MOTIONTRACKING_EVENT | Event that encodes a motion tracker position change.
BUTTON_PRESS_EVENT | Event for button press events of custom input devices.
BUTTON_RELEASE_EVENT | Event for button press events of custom input devices.
NOTIFICATION_EVENT | Event for passing BALL Messages accross threads.
RENDER_TO_BUFFER_FINISHED_EVENT | Event posted by renderers after a new buffer is available.

Definition at line 71 of file VIEW/KERNEL/common.h.

## InputDeviceButton

enum BALL::VIEW::InputDeviceButton

Enumerator
BUTTON1 |
BUTTON2 |
BUTTON3 |
BUTTON4 |
BUTTON5 |
BUTTON6 |
BUTTON7 |
BUTTON8 |
BUTTON9 |
BUTTON10 |
BUTTON11 |
BUTTON12 |

Definition at line 13 of file buttonEvent.h.

## ModelType

enum BALL::VIEW::ModelType

This properties define the available models. Add new model entries directly before MODEL_LABEL if you want them to show up in the DisplayProperties dialog! You may have to modify the following methods, if you add a new ModelType:

See also
  getModelName(ModelType type)
  getColoringName(ColoringMethod type)
  isSurfaceModel(ModelType type)
  modelMuteableByDisplayProperties(ModelType type)
  modelMustBeRebuild(ModelType type)

Enumerator
MODEL_LINES | defines the property for the model: Lines
MODEL_STICK | defines the property for the model: Stick
MODEL_BALL_AND_STICK | defines the property for the model: Ball and Stick
MODEL_VDW | defines the property for the model: Van der Waals
MODEL_SE_SURFACE | defines the property for the model: solvent-excluded surface
MODEL_SA_SURFACE | defines the property for the model: solvent-accessible surface
MODEL_BACKBONE | defines the property for the model: Backbone
MODEL_CARTOON | defines the property for the model: Cartoon
MODEL_RIBBON | defines the property for the model: Ribbon
MODEL_HBONDS | defines the property for the model: H-Bonds
MODEL_FORCES |
MODEL_LABEL | defines the property for the model: Label
MODEL_CONTOUR_SURFACE | defines the property for the model: contour surface
MODEL_GRID_SLICE |
MODEL_GRID_VOLUME |
MODEL_FIELD_LINES |
MODEL_INFORMATIONS |
MODEL_COORDINATE_SYSTEM |
MODEL_PROXIMITY_LIGHT | defines the property for the model: proximity light
MODEL_PLANE |
MODEL_SPHERE |
MODEL_UNKNOWN | unkown property

Definition at line 165 of file VIEW/KERNEL/common.h.

## Function Documentation

## ascii()

BALL_VIEW_EXPORT String BALL::VIEW::ascii | ( | const QString & | str | ) |

## calculateHistogramEqualization()

BALL_VIEW_EXPORT void BALL::VIEW::calculateHistogramEqualization | ( | const vector< float > & | values,
|  | vector< float > & | normalized_values,
|  | bool | use_absolute_values = false )

## calculateRandomPoints()

BALL_VIEW_EXPORT void BALL::VIEW::calculateRandomPoints | ( | const RegularData3D & | grid,
|  | Size | nr_points,
|  | vector< Vector3 > & | resulting_points )

calcualte a random set of points, dependening of the field strength of a grid

## chooseColor()

BALL_VIEW_EXPORT QColor BALL::VIEW::chooseColor | ( | QLabel * | label | ) |

## createFloatString()

BALL_VIEW_EXPORT String BALL::VIEW::createFloatString | ( | float | value,
|  | Size | precision )

create a string from a float and cut after a given number of digits after the dot

## createSphere()

BALL_VIEW_EXPORT vector< Vector3 > BALL::VIEW::createSphere | ( | Size | precision | ) |

## createTemporaryFilename()

BALL_VIEW_EXPORT String BALL::VIEW::createTemporaryFilename | ( |  | ) |

Create a temporary filename in the users home dir.

## cubicInterpolation()

BALL_VIEW_EXPORT void BALL::VIEW::cubicInterpolation | ( | const Vector3 & | a,
|  | const Vector3 & | b,
|  | const Vector3 & | tangent_a,
|  | const Vector3 & | tangent_b,
|  | std::vector< Vector3 > & | interpolated_values )

Uses the de-Casteljou algorithm to evalute a cubic Hermite interpolation polynomial at interpolated_values.size() equidistant values.

## focusCamera() [1/2]

BALL_VIEW_EXPORT Camera BALL::VIEW::focusCamera | ( | Composite * | composite | ) |

Focus the camera on a Composite Sends a SceneMessage.

## focusCamera() [2/2]

BALL_VIEW_EXPORT Camera BALL::VIEW::focusCamera | ( | const std::list< Vector3 > & | points | ) |

Focus the camera on a list of points, e.g. atoms or geometric objects. Sends a SceneMessage.

## getColor()

BALL_VIEW_EXPORT ColorRGBA BALL::VIEW::getColor | ( | const QLabel * | label | ) |

## getMainControl()

BALL_VIEW_EXPORT MainControl * BALL::VIEW::getMainControl | ( |  | ) |

Get MainControl This method is only to be used for code, which is not part of a ModularWidget. This function is equivalent to MainControl::getInstance(0)

## getNormal()

BALL_VIEW_EXPORT Vector3 BALL::VIEW::getNormal | ( | const Vector3 & | v | ) |

## logString()

BALL_VIEW_EXPORT void BALL::VIEW::logString | ( | const String & | data | ) |

thread safe output to logview

## operator<<() [1/2]

std::ostream & BALL::VIEW::operator<< | ( | std::ostream & | o,
|  | const FrameBufferFormat & | f )

inline

Definition at line 163 of file renderTarget.h.

## operator<<() [2/2]

std::ostream & BALL::VIEW::operator<< | ( | std::ostream & | o,
|  | const PixelFormat & | f )

inline

Definition at line 209 of file pixelFormat.h.

## processDropEvent()

BALL_VIEW_EXPORT void BALL::VIEW::processDropEvent | ( | QDropEvent * | e | ) |

## setColor()

BALL_VIEW_EXPORT void BALL::VIEW::setColor | ( | const QLabel * | label,
|  | const ColorRGBA & | color )

## setTextColor()

BALL_VIEW_EXPORT void BALL::VIEW::setTextColor | ( | QLabel * | label,
|  | const ColorRGBA & | color )

## stringToVector3()

BALL_VIEW_EXPORT bool BALL::VIEW::stringToVector3 | ( | const String & | data,
|  | Vector3 & | v )

## subdivideTriangle()

BALL_VIEW_EXPORT void BALL::VIEW::subdivideTriangle | ( | vector< Vector3 > & | results,
|  | Vector3 & | v1,
|  | Vector3 & | v2,
|  | Vector3 & | v3,
|  | Size | precision )

## vector3ToString()

BALL_VIEW_EXPORT String BALL::VIEW::vector3ToString | ( | const Vector3 & | v | ) |

## Variable Documentation

## BALL_SELECTED_COLOR

ColorRGBA BALL::VIEW::BALL_SELECTED_COLOR

extern

Static instance for the color of selected geometric objects

## BALL_SELECTED_COLOR_CHANGE_TIME

PreciseTime BALL::VIEW::BALL_SELECTED_COLOR_CHANGE_TIME

extern

## composite_to_be_ignored_for_colorprocessors_

BALL_VIEW_EXPORT Composite BALL::VIEW::composite_to_be_ignored_for_colorprocessors_

extern

A special Composite, which is ignored by all ColoringProcessors, the GeometricObjects, which have this Composite set, will be colored by the default color.

## icosaeder_indices

Position BALL::VIEW::icosaeder_indices[20][3]

extern

## icosaeder_vertices

float BALL::VIEW::icosaeder_vertices[12][3]

extern

Code to refine a icosaeder:

## SurfaceDrawingPrecisions

BALL_VIEW_EXPORT float BALL::VIEW::SurfaceDrawingPrecisions[4]

extern

Mapping from the enum to the float values of Surfaces.